const browserType = document.querySelector('html').dataset.browseMode;
// const loadElm = document.querySelector('.top-mv');
const parentElm = document.querySelectorAll('.block-parallax');
const textContElm = document.querySelectorAll('.block-content-wrap');
const childElm = document.querySelectorAll('.parallax-inner:not(.auto-playback):not(.js-prllx-bg)');
let firstCount = 0;

// --------------- パララックス終了監視

const endHeader = document.querySelector('.pane-header');
let endCount = 0;
const fadeInOptions2 = {
  root: null,
  rootMargin: '0px',
  threshold: 0.1,
};
const observer2 = new IntersectionObserver((entries, observer) => {
  entries.forEach(entry => {
    if (entry.isIntersecting) {
      // document.querySelector('.pane-header').style.transform = '';
      endHeader.classList.add('active');
      document.querySelector('.c-menu').classList.remove('is-show');
      observer2.unobserve(entry.target);
      endCount++;
    }
  });
}, fadeInOptions2);

if (browserType === 'S') {
  // SPのとき
  const endParallax = document.querySelector('.block-item-detail .item-info-detail');
  observer2.observe(endParallax);
} else {
  // PCのとき
  const endParallax = document.querySelector('.block-item-detail');
  observer2.observe(endParallax);
}

// --------------- SPのみ：テキストコンテント監視
  const innerText = document.querySelectorAll('.text-content .is-text');
  const fadeInOptions3 = {
    root: null,
    rootMargin: '-35%',
  };
  const Options3Threshold = 1.0;
  const parallaxOptions3Threshold = 0.8;
  const observer3 = new IntersectionObserver((entries, observer) => {
    entries.forEach(entry => {
      if (entry.isIntersecting) {
        entry.target.closest('.block-content-wrap').querySelector('.block-fixed-cart').classList.add('active');
      } else {
        entry.target.closest('.block-content-wrap').querySelector('.block-fixed-cart').classList.remove('active');
      }
    });
  }, fadeInOptions3);

// --------------- 親要素監視
const fadeInOptions = {
  root: null,
  rootMargin: '0px',
  threshold: 0.2,
};
const fadeInObserver = new IntersectionObserver((entries, observer) => {
  const getFirstElm = entries;
  entries.forEach((entry) => {
    if (entry.isIntersecting) {

      // 表示するとき
      if (entry.target.classList.contains('slide-text')){
        document.querySelector('.fl-banner').classList.remove('is-show');
      }
      if (entry.target.classList.contains('movie')){
        document.querySelector('.fl-banner').classList.add('is-show');
      }
      if (entry.target.classList.contains('block-slide-area')){
        document.querySelector('.c-menu').classList.remove('is-show');
      }
      if (entry.target.classList.contains('block-bnr-area')){
        document.querySelector('.c-menu').classList.add('is-show');
      }
      entry.target.classList.add('active');
      addClassWithDelay(entry.target);

      // 初回表示時
      if(entry.target.classList.contains('parallax-inner')) {
        entry.target.classList.add('already');
      }

      // また見るとき
      if(endCount > 0) {
        if (browserType === 'S') {
          // SPのとき
          const endParallax = document.querySelector('.block-item-detail .item-info-detail');
          observer2.observe(endParallax);
        } else {
          // PCのとき
          const endParallax = document.querySelector('.block-item-detail');
          observer2.observe(endParallax);
        }
        endHeader.classList.remove('active');
        document.querySelector('.c-menu').classList.add('is-show');
        endCount = 0;

      }

    } else {
      entry.target.classList.remove('active');
      if(!entry.target.classList.contains('point-list') && browserType === 'S') {
        document.querySelector('body').classList.remove('is-fixed');
      }

      if(entry.target === document.querySelector('.top-mv+.block-parallax .parallax-inner:not(.js-prllx-bg)')) {
          // if(!entry.target.classList.contains('active') && document.querySelector('.top-mv+.block-parallax.active')) {
          //     console.log('childHide');
          //     setTimeout(()=>{
          //       document.querySelector('.pane-header:not(.active)').style.transform = '';
          //     },100);
          // }
      }
    }
  });
}, fadeInOptions);

// --------------- 初期表示（自動再生）
const actions = [
  { delay: 0, selector: '.js-prllx-bg' },
  { delay: 1500, selector: '.poition-bg'},
  { delay: 200, selector: '.auto-playback'}
];
async function addClassWithDelay(target) {
  for (const action of actions) {
    await new Promise((resolve) => setTimeout(resolve, action.delay));
    target.querySelector(action.selector)?.classList.add('active');
  }
}

function gcd(x, y){
  if(y === 0) return x
  return gcd(y, x % y)
}

// --------------- 初期表示
document.querySelector('body').classList.add('is-fixed');

// --------------- ローディング画面
window.addEventListener('load', () => {
    document.querySelector('body').classList.remove('is-fixed');

    // 発火
    parentElm.forEach((elm) => fadeInObserver.observe(elm,{
      attributes: true,
      childList: true
    }));
    childElm.forEach((elm) => fadeInObserver.observe(elm,{
      attributes: true,
      childList: true
    }));
    // document.querySelectorAll('.block-parallax.point-detail').forEach(elm => {
    //   pointDetailObserver.observe(elm);
    // });

});

//----------- フローティングバナー
jQuery('.fl-banner .close').click(function(){
  jQuery(this).parent('.fl-banner').addClass('hide');
});

//--- フローティングバナーの透過
function ScrollTransparentFnc() {

  let scroll = jQuery(window).scrollTop();
  let banner = jQuery('.fl-banner');

  if( banner.length) {
    if (scroll > 100) {
      banner.addClass('fade')
    } else {
      banner.removeClass('fade')
    }
  }
}

function slideShow() {
  const images = jQuery(".js-mv-slideshow .mv-image");
  const totalImages = images.length;
  const fixedImageIndex = totalImages - 1; // 最後の画像（固定）
  let randomIndexes = [];

  // ランダムな画像の順番を生成（固定画像を除く）
  while (randomIndexes.length < totalImages - 1) {
    let randomIndex = Math.floor(Math.random() * (totalImages - 1));
    if (!randomIndexes.includes(randomIndex)) {
      randomIndexes.push(randomIndex);
    }
  }

  // ランダム画像の順番に固定画像を追加
  randomIndexes.push(fixedImageIndex);

  let currentIndex = 0;

  function showNextImage() {
    const nextIndex = randomIndexes[currentIndex];
    const currentImage = images.filter(".active");
    const nextImage = images.eq(nextIndex);

    currentImage.removeClass("active").addClass("is-shown");
    nextImage.addClass("active");

    currentIndex++;

    if (currentIndex < randomIndexes.length) {
      setTimeout(showNextImage, 4000); // 画像の表示時間 (4秒)
    }
  }

  // 最初の画像を表示
  showNextImage();
}

function slider() {
  jQuery('.js-slider01')
  .on("init", function (event, slick) {
    jQuery(this).append('<div class="slick-num"><span class="now-count"></span></div>');
    jQuery(".now-count").text(slick.currentSlide + 1); // 現在のスライド番号
  })
  .slick({
    infinite:true,
    arrows: true,
    dots: false,
    autoplay: true,
    speed: 1000,
    autoplaySpeed: 3000,
    slidesToShow: 1,
    centerMode: true,
  })
  .on("beforeChange", function (event, slick, currentSlide, nextSlide) {
    jQuery(".now-count").text('0'+ (nextSlide + 1)); // 現在のスライド番号の次のスライドになったら番号を+1
  });

  if (browserType === 'S') {
    jQuery('.js-slider02').slick({
      infinite:true,
      arrows: true,
      dots: false,
      autoplay: false,
      speed: 1000,
      slidesToShow: 1,
      centerMode: true,
    });
    jQuery('.js-slider02').closest('.block-parallax').on('transitionend', function() {
      jQuery('.js-slider02').slick('setPosition');
    });
  } else {
    jQuery('.js-slider02').slick({
      infinite:true,
      arrows: true,
      dots: false,
      autoplay: false,
      speed: 1000,
      slidesToShow: 3
    });
  }
}

function parallaxImage() {
  const elem = document.querySelector(".js-parallax");
  if (elem !== null) {
    let target = document.getElementsByClassName("js-parallax");
    let parallaxConfig = {
      orientation: "up", // 動く方向
      scale: 1.3, // 動く大きさ
      delay: .6,
      transition: 'cubic-bezier(0,0,0,1)'
    };
    const parallax_instance = new simpleParallax(target, parallaxConfig);
  }
}

function scrollAnime() {
  jQuery('.js-anime').each(function(){
    var elemPos = jQuery(this).offset().top,
        scroll = jQuery(window).scrollTop(),
        windowH = jQuery(window).height();

    if (scroll > elemPos - windowH + 150){
      if(!jQuery(this).hasClass('active')) {
        jQuery(this).addClass('active');
      }
    }
  });
}

function slideText() {
  jQuery('.slide-in').each(function () {
    jQuery(this).children().addBack().contents().each(function () {
      if (this.nodeType == 3) {
        jQuery(this).replaceWith(jQuery(this).text().replace(/(.)/g, '<span>$1</span>'));
      }
    });
    jQuery(this).css({ 'opacity': 0 });
    jQuery(this).children('span').css({ 'opacity': 0 });
  });
}

function scrollText() {
  jQuery('.slide-in').each(function () {
    if (jQuery(this).closest('.block-parallax.point-detail').hasClass('active')) {
      jQuery(this).css({ 'opacity': 1 });
      jQuery(this).children('span').each(function(i) {
        jQuery(this).delay(50 * i).animate({ 'opacity': 1 }, 800);
      });
    }
  });
}

function scrollMenu() {
  if (browserType === 'S') {
    if (jQuery('header').hasClass('is-fixed')) {
      let hHeight = jQuery('header').height();
      jQuery('.c-menu').css('top',hHeight);
    }
  }
}

jQuery(function () {
  slideShow();
  parallaxImage();
  slider();
  slideText()
});

jQuery(window).scroll(function () {
  ScrollTransparentFnc();
  scrollAnime();
  scrollText();
  scrollMenu();
});